# Extra scripts for Continuous Integration Using GitHub Actions<!-- {#page_continuous_intetration} -->

- check_component_inclusion.py
  - A python script to check that all sensor, modem, and publisher classes are included in the massive menu a la carte example.

- dependencies.json
  - A copy of the library dependencies in library.json to diff against for dependency changes.
  - The dependencies.json is automatically generated by a git pre-commit hook.

- pre-commit-check-deps.py
  - A python script to copy from the library.json to dependencies.json for rebuilding dependency archives on the GitHub actions runner.
  - This is run as a pre-commit hook

- generate_job_matrix.py
  - A python script to generate a series of shell scripts to splice apart the menu a la carte example and run each sensor, modem, and publisher as indivudual testing jobs on a number of different processors.

- install-deps-arsuino-cli.sh
  - A shell script to install all Arduino library dependencies on the GitHub actions runner used for CI testing.

- install-deps-platformio.sh
  - A shell script to install all PlatformIO library dependencies on the GitHub actions runner used for CI testing.

- continuous_integration/platformio.ini
  - PlatformIO environments for CI testing

- continuous_integration/platformio_extra_flags.ini
  - Even more PlatformIO environments for CI testing
